module mod_bellman
use mod_globvar
use mod_utilities
implicit none
contains
real(8) function bellman_w(nq,q)
implicit none
integer, intent(in) :: nq
real(8), intent(in) :: q(nq)    
real(8) :: c, as, ls, EV_1, EV_2, EV_3, EV_4, EV_1_u, EV_2_u, EV_3_u, EV_4_u
integer :: jz
ls = q(1) 
as = q(2)   
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT = y_gross - tau_ss*min(y_gross,ymax)  
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) - as)/(1.0d0+tau_c),1d-10)   
x_prime = (x(ix)*(dble(tsol)-1.0d0) + min(y_gross,ymax))/dble(tsol)
x_prime = min(max(x_prime,x(1)),x(xgrid))    
a_prime = min(max(as,a(1)),a(agrid))      
bellman_w = - util(c,ls,dble(tsol),as) - beta*lininterp2(a,x,EV_w(:,iu,iz,:),a_prime,x_prime)                                           
end function bellman_w
real(8) function bellman_w_out(as)
implicit none
real(8), intent(in) :: as  
real(8) :: c, ls
ls = 0.0d0
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT = y_gross - tau_ss*min(y_gross,ymax)  
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) - as)/(1.0d0+tau_c),1d-10)   
x_prime = (x(ix)*(dble(tsol)-1.0d0) + min(y_gross,ymax))/dble(tsol)
x_prime = min(max(x_prime,x(1)),x(xgrid))    
a_prime = min(max(as,a(1)),a(agrid))       
bellman_w_out = - util_out(c,ls,dble(tsol),as) - beta*lininterp2(a,x,EV_w(:,iu,iz,:),a_prime,x_prime)                                           
end function bellman_w_out
real(8) function bellman_w_tr(nq,q)
implicit none
integer, intent(in) :: nq
real(8), intent(in) :: q(nq)    
real(8) :: c, as, ls, EV_1, EV_2, EV_3, EV_4
integer :: jz
ls = q(1) 
as = q(2)    
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT = y_gross - tau_ss*min(y_gross,ymax)  
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max ( ((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)   
x_prime = (x(ix)*(dble(tsol)-1.0d0) + min(y_gross,ymax))/dble(tsol)
x_prime = min(max(x_prime,x(1)),x(xgrid))   
a_prime = min(max(as,a(1)),a(agrid))
bellman_w_tr = - util(c,ls,dble(tsol),as) - beta*(psi(tsol+1)*lininterp2(a,x,V_ret(:,:,tsol+1),a_prime,x_prime) + (1.0d0-psi(tsol+1))*util_beq(as)) 	                                                         
end function bellman_w_tr
real(8) function bellman_w_tr_out(as)
implicit none
real(8), intent(in) :: as    
real(8) :: c, ls
ls = 0.0d0     
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT = y_gross - tau_ss*min(y_gross,ymax)  
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max ( ((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c) , 1d-10 )   
x_prime = (x(ix)*(dble(tsol)-1.0d0) + min(y_gross,ymax))/dble(tsol)
x_prime = min(max(x_prime,x(1)),x(xgrid))
a_prime = min(max(as,a(1)),a(agrid))        
bellman_w_tr_out = - util_out(c,ls,dble(tsol),as) - beta*(psi(tsol+1)*lininterp2(a,x,V_ret(:,:,tsol+1),a_prime,x_prime) + (1.0d0-psi(tsol+1))*util_beq(as)) 	                                                         
end function bellman_w_tr_out
real(8) function bellman_ret(nq,q)
implicit none
integer, intent(in) :: nq
real(8), intent(in) :: q(nq)    
real(8) :: c, as, ls
ls = q(1) 
as = q(2)
res = (1.0d0+r)*a(ia) + ben_func(x(ix)) + beq 
c = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + ben_func(x(ix)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)
a_prime = min(max(as,a(1)),a(agrid))
ind = minloc(abs(a-a_prime))
if (a(ind(1))==a(1)) then
ja1 = ind(1)
ja2 = ind(1)+1.0d0
goto 156
elseif (a(ind(1))==a(agrid)) then
ja1 = ind(1)-1.0d0
ja2 = ind(1)
goto 156
else
if (a(ind(1))<a_prime) then
ja1 = ind(1)
ja2 = ind(1)+1.0d0
goto 156
elseif (a(ind(1))>a_prime) then
ja1 = ind(1)-1.0d0
ja2 = ind(1)
goto 156
endif
endif
156 pa1 = (a(ja2)-a_prime)/(a(ja2)-a(ja1))       
bellman_ret = - util_out(c,ls,dble(tsol),as) - beta*( psi(dble(tsol)+1.0d0)*(pa1*V_ret(ja1,ix,tsol+1) + (1.0d0-pa1)*V_ret(ja2,ix,tsol+1)) + (1.0d0-psi(dble(tsol)+1.0d0))*util_beq(as))
end function bellman_ret
real(8) function bellman_ret_last_period(nq,q)
implicit none
integer, intent(in) :: nq
real(8), intent(in) :: q(nq)    
real(8) :: c, as, ls
ls = q(1) 
as = q(2)
res = (1.0d0+r)*a(ia) + ben_func(x(ix)) + beq 
c = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + ben_func(x(ix)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)
bellman_ret_last_period = - util_out(c,ls,dble(tsol),as) - beta*util_beq(as)
end function bellman_ret_last_period
real(8) function bellman_w_ndc(nq,q)
implicit none
integer, intent(in) :: nq
real(8), intent(in) :: q(nq)    
real(8) :: c, as, ls, ts, yT
integer :: jz
ls = q(1) 
as = q(2)
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT= y_gross - tau_ss_func(dble(tsol))*y_gross 
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max ( ((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)   
x_prime = (1.0d0+r_ben)*x(ix) + tau_ss_func(dble(tsol))*y_gross 
x_prime = min(max(x_prime,x(1)),x(xgrid))    
a_prime = min(max(as,a(1)),a(agrid))
bellman_w_ndc = - util(c,ls,dble(tsol),as) - beta*lininterp2(a,x,EV_w(:,iu,iz,:),a_prime,x_prime)                                                                                   
end function bellman_w_ndc
real(8) function bellman_w_ndc_out(as)
implicit none
real(8), intent(in) :: as  
real(8) :: c, ls
ls = 0.0d0 
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT= y_gross - tau_ss_func(dble(tsol))*y_gross  
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max ( ((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)   
x_prime = (1.0d0+r_ben)*x(ix) + tau_ss_func(dble(tsol))*y_gross 
x_prime = min(max(x_prime,x(1)),x(xgrid))    
a_prime = min(max(as,a(1)),a(agrid))    
bellman_w_ndc_out = - util_out(c,ls,dble(tsol),as) - beta*lininterp2(a,x,EV_w(:,iu,iz,:),a_prime,x_prime)                                                                                            
end function bellman_w_ndc_out
real(8) function bellman_w_tr_ndc(nq,q)
implicit none
integer, intent(in) :: nq
real(8), intent(in) :: q(nq)    
real(8) :: c, as, ls, ts, yT
integer :: jz
ls = q(1) 
as = q(2)
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT = y_gross - tau_ss_func(dble(tsol))*y_gross 
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max ( ((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)   
x_prime = (1.0d0+r_ben)*x(ix) + tau_ss_func(dble(tsol))*y_gross 
x_prime = min(max(x_prime,xmin),xmax) 
a_prime = min(max(as,a(1)),a(agrid))        
bellman_w_tr_ndc = - util(c,ls,dble(tsol),as) - beta*( psi(tsol+1)*lininterp2(a,x,V_ret(:,:,tsol+1),a_prime,x_prime) + (1.0d0-psi(tsol+1))*util_beq(as))                                             
end function bellman_w_tr_ndc
real(8) function bellman_w_tr_ndc_out(as)
implicit none
real(8), intent(in) :: as    
real(8) :: c, ls
ls = 0.0d0 
y_gross = y_func(ls,u(iu),z(iz),tsol)
yT = y_gross - tau_ss_func(dble(tsol))*y_gross  
res = (1.0d0+r)*a(ia) + y_gross + beq        
c = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)   
x_prime = (1.0d0+r_ben)*x(ix) + tau_ss_func(dble(tsol))*y_gross 
x_prime = min(max(x_prime,xmin),xmax) 
a_prime = min(max(as,a(1)),a(agrid))    
bellman_w_tr_ndc_out = - util_out(c,ls,dble(tsol),as) - beta*( psi(tsol+1)*lininterp2(a,x,V_ret(:,:,tsol+1),a_prime,x_prime) + (1.0d0-psi(tsol+1))*util_beq(as))                                            
end function bellman_w_tr_ndc_out
real(8) function foc(cev)
implicit none
real(8), intent(in) :: cev    
real(8) :: EU_bench, EU_opt
integer :: t
EU_bench = 0.0d0
EU_opt   = 0.0d0
do t=1,ntime
EU_bench =  EU_bench + (beta**dble(t-1))*nu(t)*((1.0d0+cev)**((1.0d0-rho_func(t))*(1.0d0-dble(gamma))))*sum(utility1_sim_bench(:,t))
EU_opt = EU_opt + (beta**dble(t-1))*nu(t)*sum(utility1_sim(:,t))
enddo  
foc = abs(EU_bench/dble(nsim) - EU_opt/dble(nsim))
end function foc
real(8) function foc_low(cev)
implicit none
real(8), intent(in) :: cev    
real(8) :: EU_bench, EU_opt
integer :: t
EU_bench = 0.0d0
EU_opt   = 0.0d0
do t=1,ntime
EU_bench = EU_bench + (beta**dble(t-1))*nu(t)*((1.0d0+cev)**((1.0d0-rho_func(t))*(1.0d0-dble(gamma))))*utility_sim_bench_low(t)
EU_opt = EU_opt + (beta**dble(t-1))*nu(t)*utility1_sim_low(t)
enddo  
foc_low = abs(EU_bench-EU_opt) 
end function foc_low
real(8) function foc_high(cev)
implicit none
real(8), intent(in) :: cev    
real(8) :: EU_bench, EU_opt
integer :: t
EU_bench = 0.0d0
EU_opt = 0.0d0
do t=1,ntime
EU_bench = EU_bench + (beta**dble(t-1))*nu(t)*( (1.0d0+cev)**((1.0d0-rho_func(t))*(1.0d0-dble(gamma))))*utility_sim_bench_high(t)
EU_opt = EU_opt + (beta**dble(t-1))*nu(t)*utility1_sim_high(t)
enddo
foc_high = abs(EU_bench-EU_opt) 
end function foc_high
real(8) function foc_level(cev)
implicit none
real(8), intent(in) :: cev    
real(8) :: EU_bench, EU_opt
integer :: t
EU_bench = 0.0d0
EU_opt   = 0.0d0
do t=1,ntime
EU_bench =  EU_bench + (beta**dble(t-1))*nu(t)*((1.0d0+cev)**((1.0d0-rho_func(t))*(1.0d0-dble(gamma))))*util(c_bench(t),l_bench(t),dble(t),0.0d0)
EU_opt = EU_opt + (beta**dble(t-1))*nu(t)*util(cage(t),lage(t),dble(t),0.0d0)
enddo
foc_level = abs(EU_bench-EU_opt)
end function foc_level
end module mod_bellman