module mod_initialize
use mod_globvar
use mod_probability
use mod_utilities
implicit none
contains
subroutine init
implicit none
integer :: j, iz_temp(ntime)
real(8) :: sample_sim(ntime,2,nsim),draw_sim(nsim), um_1, um_2, um_3, um_4, um_5, um_6, um_7, um_8, um_9
real(8) :: draw, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, step, u1(ugrid)
real(8) :: Ptemp(zgrid,zgrid), Pbar(zgrid), Ptemp_u(ugrid,ugrid)
real(8) :: mean_a1 = 0.0136d0
real(8) :: mean_a2 = 0.0234d0
real(8) :: mean_a3 = 0.0348d0
real(8) :: mean_a4 = 0.0548d0
real(8) :: mean_a5 = 0.0866d0
real(8) :: mean_a6 = 0.1355d0
real(8) :: mean_a7 = 0.2090d0
real(8) :: mean_a8 = 0.8334d0
real(8) :: mean_a9 = 1.2813d0
real(8) :: std_a1 = 0.025d0
real(8) :: std_a2 = 0.033d0
real(8) :: std_a3 = 0.056d0
real(8) :: std_a4 = 0.083d0
real(8) :: std_a5 = 0.128d0
real(8) :: std_a6 = 0.192d0
real(8) :: std_a7 = 0.279d0
real(8) :: std_a8 = 0.389d0
real(8) :: std_a9 = 0.544d0
if (model==0.0d0) then
xmin = 0.0001d0
xmax = 0.965d0
elseif (model==1.0d0) then
xmin = amin
xmax = amax_ndc
endif
do t=1,ntime
sigma(t)=0.0115d0
enddo
a(1) = amin
do i = 2,agrid
a(i) = a(1) + (amax/(dble(agrid)**2.35d0))*(dble(i)**2.35d0)
enddo   
x(1) = xmin
do i = 2,xgrid
x(i) = x(1) + (xmax/(dble(xgrid)**2.35d0))*(dble(i)**2.35d0)
enddo   
l_bench = 0.0d0
OPEN(20, FILE='l_bench.txt',FORM='FORMATTED', ACTION='READ', STATUS='OLD')
READ(20,*) (l_bench(t),t=1,ret_age-1) 
OPEN(21, FILE='c_bench.txt',FORM='FORMATTED', ACTION='READ', STATUS='OLD')
READ(21,*) (c_bench(t),t=1,ntime) 
call tauchen(int(zgrid),rho_z,mean_z,std_e,z,Pr_z)
Ptemp = Pr_z
do t=1,10000
Ptemp = matmul(Pr_z,Ptemp)
enddo
Pbar = Ptemp(1,:)
call tauchen(int(ugrid),0.0d0,mean_u,std_u,u,Ptemp_u)
Pr_u = Ptemp_u(1,:)
rho_func(1)=0.70d0       
do t=2,ntime                                                             
if (t<10.0d0) then
rho_func(t) = rho_func(t-1) - 0.0140d0                                              
elseif ((t>=10.0d0).and.(t<37.0d0)) then
rho_func(t) = rho_func(t-1) - 0.0023d0 
elseif ((t>=37.0d0).and.(t<45.0d0)) then
rho_func(t) = rho_func(t-1) 
else    
rho_func(t) = rho_func(t-1)
endif                                          
enddo
lmin_func=0.00d0
chi_age(1)=0.00d0       
do t=20,45                
chi_age(t) = 0.020d0*(dble(t)-20.0d0)      
enddo
OPEN(10, FILE='ef.txt',FORM='FORMATTED', ACTION='READ', STATUS='OLD')
READ(10,*) (ef_temp(t),t=1,ret_age-1) 
OPEN(16, FILE='psurv.txt',FORM='FORMATTED', ACTION='READ', STATUS='OLD')
READ(16,*) (psi(t),t=1,ntime) 
mu(1) = 1.0d0
do t=2,ntime
mu(t) = (psi(t)/(1.0d0+dble(gn)))*mu(t-1)
enddo
step = sum(mu)
do t=1,ntime
mu(t) = mu(t)/step
enddo
t = 1
do i=1,nsim
p1 = max(min(Pbar(1),1.0d0-eps),eps)
p2 = max(min(sum(Pbar(1:2)),1.0d0-eps),eps)
p3 = max(min(sum(Pbar(1:3)),1.0d0-eps),eps)
p4 = max(min(sum(Pbar(1:4)),1.0d0-eps),eps)
p5 = max(min(sum(Pbar(1:5)),1.0d0-eps),eps)
p6 = max(min(sum(Pbar(1:6)),1.0d0-eps),eps)
p7 = max(min(sum(Pbar(1:7)),1.0d0-eps),eps)
p8 = max(min(sum(Pbar(1:8)),1.0d0-eps),eps)
p9 = max(min(sum(Pbar(1:9)),1.0d0-eps),eps)
p10 = max(min(sum(Pbar(1:10)),1.0d0-eps),eps)
p11 = max(min(sum(Pbar(1:11)),1.0d0-eps),eps)
draw = sample_normal(0.0d0,1.0d0)
if (draw <= INVNORMCDF(p1,0.0d0,1.0d0) ) then 
iz_sim(i,t) = 1.0d0
else if ((draw > INVNORMCDF(p1,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p2,0.0d0,1.0d0))) then
iz_sim(i,t) = 2.0d0
else if ((draw > INVNORMCDF(p2,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p3,0.0d0,1.0d0))) then
iz_sim(i,t) = 3.0d0
else if ((draw > INVNORMCDF(p3,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p4,0.0d0,1.0d0))) then
iz_sim(i,t) = 4.0d0
else if ((draw > INVNORMCDF(p4,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p5,0.0d0,1.0d0))) then
iz_sim(i,t) = 5.0d0
else if ((draw > INVNORMCDF(p5,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p6,0.0d0,1.0d0))) then
iz_sim(i,t) = 6.0d0    
else if ((draw > INVNORMCDF(p6,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p7,0.0d0,1.0d0))) then
iz_sim(i,t) = 7.0d0    
else if ((draw > INVNORMCDF(p7,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p8,0.0d0,1.0d0))) then
iz_sim(i,t) = 8.0d0    
else if ((draw > INVNORMCDF(p8,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p9,0.0d0,1.0d0))) then
iz_sim(i,t) = 9.0d0    
else if ((draw > INVNORMCDF(p9,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p10,0.0d0,1.0d0))) then
iz_sim(i,t) = 10.0d0  
else if ((draw > INVNORMCDF(p10,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p11,0.0d0,1.0d0))) then
iz_sim(i,t) = 11.0d0  
end if            
enddo
um_1 = 0.0d0
um_2 = 0.0d0
um_3 = 0.0d0
um_4 = 0.0d0
um_5 = 0.0d0
um_6 = 0.0d0
um_7 = 0.0d0
um_8 = 0.0d0
t = 1
do i=1,nsim
p1 = max(min(Pr_u(1),1.0d0-eps),eps)
p2 = max(min(sum(Pr_u(1:2)),1.0d0-eps),eps)
p3 = max(min(sum(Pr_u(1:3)),1.0d0-eps),eps)
p4 = max(min(sum(Pr_u(1:4)),1.0d0-eps),eps)
p5 = max(min(sum(Pr_u(1:5)),1.0d0-eps),eps)
p6 = max(min(sum(Pr_u(1:6)),1.0d0-eps),eps)
p7 = max(min(sum(Pr_u(1:7)),1.0d0-eps),eps)
p8 = max(min(sum(Pr_u(1:8)),1.0d0-eps),eps)
dra_u_ini(i) = sample_normal(0.0d0,1.0d0)
draw = dra_u_ini(i) 
if (draw <= INVNORMCDF(p1,0.0d0,1.0d0) ) then 
iu_sim(i,t) = 1.0d0
else if ((draw > INVNORMCDF(p1,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p2,0.0d0,1.0d0))) then
iu_sim(i,t) = 2.0d0
else if ((draw > INVNORMCDF(p2,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p3,0.0d0,1.0d0))) then
iu_sim(i,t) = 3.0d0    
else if ((draw > INVNORMCDF(p3,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p4,0.0d0,1.0d0))) then
iu_sim(i,t) = 4.0d0     
else if ((draw > INVNORMCDF(p4,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p5,0.0d0,1.0d0))) then
iu_sim(i,t) = 5.0d0        
else if ((draw > INVNORMCDF(p5,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p6,0.0d0,1.0d0))) then
iu_sim(i,t) = 6.0d0        
else if ((draw > INVNORMCDF(p6,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p7,0.0d0,1.0d0))) then
iu_sim(i,t) = 7.0d0        
else if ((draw > INVNORMCDF(p7,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p8,0.0d0,1.0d0))) then
iu_sim(i,t) = 8.0d0        
else if (draw > INVNORMCDF(p8,0.0d0,1.0d0)) then
iu_sim(i,t) = 9.0d0        
end if
u_ini(i) = dra_u_ini(i)      
u_ini(i) = dexp(u_ini(i))
dra_a_ini(i) = sample_normal(0.0d0,1.0d0) 
enddo
do i=1,nsim
do t=2,ntime
iu_sim(i,t) = iu_sim(i,t-1)
p1 = max(min(Pr_z(iz_sim(i,t-1),1),1.0d0-eps),eps)
p2 = max(min(sum(Pr_z(iz_sim(i,t-1),1:2)),1.0d0-eps),eps)
p3 = max(min(sum(Pr_z(iz_sim(i,t-1),1:3)),1.0d0-eps),eps)
p4 = max(min(sum(Pr_z(iz_sim(i,t-1),1:4)),1.0d0-eps),eps)
p5 = max(min(sum(Pr_z(iz_sim(i,t-1),1:5)),1.0d0-eps),eps)
p6 = max(min(sum(Pr_z(iz_sim(i,t-1),1:6)),1.0d0-eps),eps)
p7 = max(min(sum(Pr_z(iz_sim(i,t-1),1:7)),1.0d0-eps),eps)
p8 = max(min(sum(Pr_z(iz_sim(i,t-1),1:8)),1.0d0-eps),eps)
p9 = max(min(sum(Pr_z(iz_sim(i,t-1),1:9)),1.0d0-eps),eps)
p10 = max(min(sum(Pr_z(iz_sim(i,t-1),1:10)),1.0d0-eps),eps)
p11 = max(min(sum(Pr_z(iz_sim(i,t-1),1:11)),1.0d0-eps),eps)
draw = sample_normal(0.0d0,1.0d0)
if (draw <= INVNORMCDF(p1,0.0d0,1.0d0) ) then 
iz_sim(i,t) = 1.0d0
else if ((draw > INVNORMCDF(p1,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p2,0.0d0,1.0d0))) then
iz_sim(i,t) = 2.0d0
else if ((draw > INVNORMCDF(p2,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p3,0.0d0,1.0d0))) then
iz_sim(i,t) = 3.0d0
else if ((draw > INVNORMCDF(p3,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p4,0.0d0,1.0d0))) then
iz_sim(i,t) = 4.0d0
else if ((draw > INVNORMCDF(p4,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p5,0.0d0,1.0d0))) then
iz_sim(i,t) = 5.0d0
else if ((draw > INVNORMCDF(p5,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p6,0.0d0,1.0d0))) then
iz_sim(i,t) = 6.0d0    
else if ((draw > INVNORMCDF(p6,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p7,0.0d0,1.0d0))) then
iz_sim(i,t) = 7.0d0    
else if ((draw > INVNORMCDF(p7,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p8,0.0d0,1.0d0))) then
iz_sim(i,t) = 8.0d0    
else if ((draw > INVNORMCDF(p8,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p9,0.0d0,1.0d0))) then
iz_sim(i,t) = 9.0d0    
else if ((draw > INVNORMCDF(p9,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p10,0.0d0,1.0d0))) then
iz_sim(i,t) = 10.0d0  
else if ((draw > INVNORMCDF(p10,0.0d0,1.0d0)).and.(draw <= INVNORMCDF(p11,0.0d0,1.0d0))) then
iz_sim(i,t) = 11.0d0  
end if            
enddo
enddo
OPEN(61, FILE="sample_sim.dat", FORM="unformatted")  
DO t = 1, ntime  
DO i = 1, nsim  
sample_sim(t,1,i) = iu_sim(i,t)
sample_sim(t,2,i) = iz_sim(i,t)
END DO
END DO  
WRITE(61) sample_sim  
CLOSE(61)  
OPEN(69, FILE="draw_sim.dat", FORM="unformatted")  
DO i = 1, nsim  
draw_sim(i) = dra_a_ini(i)
END DO  
WRITE(69) draw_sim  
CLOSE(69)  
!iu_sim = 0.0d0
!iz_sim = 0.0d0
!OPEN(62, FILE="sample_sim.dat", FORM="unformatted")  
!READ(62) sample_sim  
!DO t = 1, ntime  
!DO i = 1, nsim  
!iu_sim(i,t) = sample_sim(t,1,i) 
!iz_sim(i,t) = sample_sim(t,2,i) 
!END DO
!END DO
!CLOSE(62)  
!OPEN(70, FILE="draw_sim.dat", FORM="unformatted")  
!READ(70) draw_sim  
!DO i = 1, nsim  
!dra_a_ini(i) = draw_sim(i) 
!END DO
!CLOSE(70)  
!OPEN(82, FILE="utility_bench.dat", FORM="unformatted")  
!READ(82) utility_sim_bench
!DO t = 1, ntime  
!DO i = 1, nsim  
!utility1_sim_bench(i,t) = utility_sim_bench(i,t) 
!END DO
!END DO
!CLOSE(82)  
nsim_low =0.0d0
nsim_high=0.0d0
do i=1,nsim
if (iu_sim(i,1)==1.0d0) then
nsim_low = nsim_low + 1.0d0
endif
if (iu_sim(i,1)==9.0d0) then
nsim_high = nsim_high + 1.0d0
endif
enddo
pop_all = nsim
utility_sim_bench_low =0.0d0
utility_sim_bench_high=0.0d0
do t=1,ntime
do i=1,nsim
if (iu_sim(i,1)==1.0d0) then
utility_sim_bench_low(t) = utility_sim_bench_low(t) + utility1_sim_bench(i,t)/dble(nsim_low)
endif
if (iu_sim(i,1)==9.0d0) then
utility_sim_bench_high(t) = utility_sim_bench_high(t) + utility1_sim_bench(i,t)/dble(nsim_high)
endif
enddo
enddo
do t=1,ntime
if (t<ret_age) then
nu(t) = 1.0d0
else
nu(t) = product(psi(1:t))
endif
enddo
end subroutine init

end module mod_initialize