module mod_sim_w_tr
use mod_globvar
use mod_probability
use mod_utilities
implicit none
contains
subroutine sim_w_tr
implicit none
if (psim(i,t-1)==1.0d0) then  
asim(i,t) = lininterp2(a,x,a_w(:,iu_sim(i,t-1),iz_sim(i,t-1),:,t-1),asim(i,t-1),xsim(i,t-1)) 
if (model==0.0d0) then  
xsim(i,t) = (xsim(i,t-1)*(dble(t)-1.0d0) + min(ysim(i,t-1),ymax))/dble(t)
xsim(i,t) = min(max(xsim(i,t),x(1)),x(xgrid))
elseif (model==1.0d0) then  
xsim(i,t) = (1.0d0+r_ben)*xsim(i,t-1) + tau_ss_func(dble(t-1))*ysim(i,t-1) 
xsim(i,t) = min(max(xsim(i,t),x(1)),x(xgrid))
endif
else
asim(i,t) = lininterp2(a,x,a_w_out(:,iu_sim(i,t-1),iz_sim(i,t-1),:,t-1),asim(i,t-1),xsim(i,t-1)) 
if (model==0.0d0) then  
xsim(i,t) = (xsim(i,t-1)*(dble(t)-1.0d0) + min(ysim(i,t-1),ymax))/dble(t)
xsim(i,t) = min(max(xsim(i,t),x(1)),x(xgrid))
elseif (model==1.0d0) then  
xsim(i,t) = (1.0d0+r_ben)*xsim(i,t-1) + tau_ss_func(dble(t-1))*ysim(i,t-1) 
xsim(i,t) = min(max(xsim(i,t),x(1)),x(xgrid))
endif
endif
Vsim(i,t) = lininterp2(a,x,V_ret(:,:,t),asim(i,t),xsim(i,t))
lsim(i,t) = 0.0d0
csim(i,t) = max(lininterp2(a,x,c_ret(:,:,t),asim(i,t),xsim(i,t)),1d-10)
ysim(i,t) = ben_func(xsim(i,t)) 
res = (1.0d0+r)*asim(i,t) + ysim(i,t) + beq 
trans_sim(i,t) = trans(cmin,res)
a_bar = max(asim(i,t),a_bar)
x_bar = max(xsim(i,t),x_bar)
d_csim(i,t) = dlog(csim(i,t))-dlog(csim(i,t-1)) 
d_zsim(i,t) = z(iz_sim(i,t))-z(iz_sim(i,t-1))
if (iu_sim(i,t)==1.0d0) then
d_csim_low(i,t) = dlog(csim(i,t))-dlog(csim(i,t-1)) 
d_zsim_low(i,t) = z(iz_sim(i,t))-z(iz_sim(i,t-1))
endif
if (iu_sim(i,t)==dble(ugrid)) then
d_csim_high(i,t) = dlog(csim(i,t))-dlog(csim(i,t-1)) 
d_zsim_high(i,t) = z(iz_sim(i,t))-z(iz_sim(i,t-1))
endif
if (model==0.0d0) then  
yT = ysim(i,t)-tau_ss*min(ysim(i,t),ymax) 
rev_ss_sim(i,t) = tau_ss*min(ysim(i,t),ymax) 
ltax(i,t) = Tax_func(yT,zeta_1,zeta_2,dble(t))
ltax1(i,t) = yT**(1.0d0-dble(alpha))
ltax2(i,t) = yT - zeta_2*((19.0d0+dble(t))/10.0d0)*(yT**(1.0d0-dble(alpha))) 
yTsim(i,t) = yT 
y_total_sim(i,t) = r*asim(i,t) 
y_total_net_sim(i,t) = (1.0d0-tau_k)*r*asim(i,t) + ysim(i,t) + trans_sim(i,t)
elseif (model==1.0d0) then  
yT = ysim(i,t) - tau_ss_func(dble(t))*ysim(i,t)
rev_ss_sim(i,t) = tau_ss_func(dble(t))*ysim(i,t)
ltax(i,t) = Tax_func(yT,zeta_1,zeta_2,dble(t)) 
ltax1(i,t) = yT**(1.0d0-dble(alpha))
ltax2(i,t) = yT - zeta_2*((19.0d0+dble(t))/10.0d0)*(yT**(1.0d0-dble(alpha))) 
yTsim(i,t) = yT
y_total_sim(i,t) = r*asim(i,t) 
y_total_net_sim(i,t) = (1.0d0-tau_k)*r*asim(i,t) + ysim(i,t) + trans_sim(i,t)
endif  
if ((csim(i,t)>0.0d0).AND.(lsim(i,t)>=0.0d0).AND.(lsim(i,t)<=1.0d0)) then
utility1_sim(i,t) = util_out(csim(i,t),lsim(i,t),dble(t),asim(i,t))
else
pause
endif
end subroutine sim_w_tr

end module mod_sim_w_tr
