module mod_simulation
use mod_globvar
use mod_probability
use mod_utilities
use mod_bellman
use mod_sim_w
use mod_sim_w_tr
use mod_sim_ret
use toolbox
implicit none
contains
subroutine simulation
implicit none
real(8) :: aage(ntime), labor_age(ntime), iage(ntime), xage(ntime), page(ntime), y_all_ret(nsim*(ntime-ret_age+1))
real(8) :: cage_l(ntime), cage_h(ntime), xm, yage(ntime), savings_age_l(ntime), savings_age_h(ntime)
real(8) :: lage_m(ntime), cage_m(ntime), sage_m(ntime)
real(8) :: lm, cm, Yf, kl1, ltaxm, EV1, EV1_ls, EV1_hs, avg_util, avg_util_ls, avg_util_hs, inhe1, REV
real(8) :: lage_l(ntime), lage_h(ntime), sage_l(ntime), sage_h(ntime), utility_age(ntime), sav_age(ntime), total_sav_age(ntime)
real(8) :: utility_m, ltaxm1, ltaxm2, tax_age1(ntime), tax_age2(ntime), numer(2,2), den(2,2)
real(8) :: total_savings_age(ntime), savings_age(ntime), trans_m, trans_age(ntime)
real(8) :: savings_m, vp_y_net(nsim), vp_y_net_l(nsim), vp_y_net_h(nsim)
real(8) :: aage_l(ntime), aage_h(ntime), xage_l(ntime), xage_h(ntime), aage_m(ntime), xage_m(ntime), bm, savings_l, savings_h
real(8) :: cev, tax_age(ntime), theta(nsim), theta_l, theta_m, theta_h
real(8) :: total_pop_assets, rev_ss_age(ntime), rev_ss, rev_w, avg_inc_sim(nsim)
real(8) :: theta_0_20, theta_20_40, theta_40_60, theta_60_80, theta_80_100, xtemp4(1), theta_mean
real(8) :: vp_c_l(nsim), vp_c(nsim), vp_c_h(nsim), y_total
real(8) :: vp_y_l(nsim), vp_y(nsim), vp_y_h(nsim), t_age(ntime), tage_l(ntime), tage_m(ntime), tage_h(ntime), tm, pm
real(8) :: y_all(nsim*ntime), y_all_net(nsim*ntime), a_all(nsim*ntime), pop(nsim*ntime)
real(8) :: tax_wage(nsim*(ret_age-1)), wage(nsim*(ret_age-1)), am_total, y_age_m(nsim)
real(8) :: covar, var, covar_2, var_2, covar_10, var_10, covar_20, var_20, mean_d_csim, mean_d_zsim, mean_asim, mean_usim
real(8) :: covar_30, var_30, covar_40, var_40, am_t1
real(8) :: mean_a1_new, std_a1_new, mean_a2_new, std_a2_new, mean_a3_new, std_a3_new, mean_a4_new, std_a4_new, mean_a5_new, std_a5_new
real(8) :: mean_a6_new, std_a6_new, mean_a7_new, std_a7_new, mean_a8_new, std_a8_new, mean_a9_new, std_a9_new
real(8) :: mean_a1_age(ntime), mean_a2_age(ntime), mean_a3_age(ntime), mean_a4_age(ntime), mean_a5_age(ntime), mean_a6_age(ntime), mean_a7_age(ntime), mean_a8_age(ntime), mean_a9_age(ntime)
real(8) :: var_a1_age(ntime), var_a2_age(ntime), var_a3_age(ntime), var_a4_age(ntime), var_a5_age(ntime), var_a6_age(ntime), var_a7_age(ntime), var_a8_age(ntime), var_a9_age(ntime)
real(8) :: covar_low, var_low, covar_high, var_high, mean_d_csim_low, mean_d_zsim_low, mean_d_csim_high, mean_d_zsim_high
integer :: i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15
a_bar=0.0d0
x_bar=0.0d0
t=1
do i=1,nsim
if (iu_sim(i,t)==1.0d0) then
a_ini(i) = mean_a1 + std_a1*dra_a_ini(i) 
elseif (iu_sim(i,t)==2.0d0) then
a_ini(i) = mean_a2 + std_a2*dra_a_ini(i)  
elseif (iu_sim(i,t)==3.0d0) then
a_ini(i) = mean_a3 + std_a3*dra_a_ini(i)  
elseif (iu_sim(i,t)==4.0d0) then
a_ini(i) = mean_a4 + std_a4*dra_a_ini(i)  
elseif (iu_sim(i,t)==5.0d0) then
a_ini(i) = mean_a5 + std_a5*dra_a_ini(i)  
elseif (iu_sim(i,t)==6.0d0) then
a_ini(i) = mean_a6 + std_a6*dra_a_ini(i)  
elseif (iu_sim(i,t)==7.0d0) then
a_ini(i) = mean_a7 + std_a7*dra_a_ini(i)  
elseif (iu_sim(i,t)==8.0d0) then
a_ini(i) = mean_a8 + std_a8*dra_a_ini(i)  
elseif (iu_sim(i,t)==9.0d0) then
a_ini(i) = mean_a9 + std_a9*dra_a_ini(i)  
endif
enddo
open(unit=854,file='a_ini.txt', ACTION="write", STATUS="replace")
do i=1,nsim
write(854,*) a_ini(i), iu_sim(i,t), iz_sim(i,t) 
enddo
close(854)
t=1
do i=1,nsim  
asim(i,t) = min(max(a_ini(i),amin),amax)
xsim(i,t) = xmin
V1 = lininterp2(a,x,V_w(:,iu_sim(i,t),iz_sim(i,t),:,t),asim(i,t),xsim(i,t))
V0 = lininterp2(a,x,V_w_out(:,iu_sim(i,t),iz_sim(i,t),:,t),asim(i,t),xsim(i,t))
if (V1>V0) then
psim(i,t) = 1.0d0
Vsim(i,t) = V1
lsim(i,t) = lininterp2(a,x,l_w(:,iu_sim(i,t),iz_sim(i,t),:,t),asim(i,t),xsim(i,t))
lsim(i,t) = min(max(lsim(i,t),lmin_func(t)),1.0d0)
csim(i,t) = max(lininterp2(a,x,c_w(:,iu_sim(i,t),iz_sim(i,t),:,t),asim(i,t),xsim(i,t)),1d-10)
ysim(i,t) = y_func(lsim(i,t),u(iu_sim(i,t)),z(iz_sim(i,t)),t) 
res = (1.0d0+r)*asim(i,t) + ysim(i,t) + beq 
trans_sim(i,t) = trans(cmin,res)
if (model==0.0d0) then  
yT = ysim(i,t)-tau_ss*min(ysim(i,t),ymax) 
rev_ss_sim(i,t) = tau_ss*min(ysim(i,t),ymax) 
ltax(i,t) = Tax_func(yT,zeta_1,zeta_2,dble(t))
ltax1(i,t) = yT**(1.0d0-dble(alpha))
ltax2(i,t) = yT - zeta_2*((19.0d0+dble(t))/10.0d0)*(yT**(1.0d0-dble(alpha))) 
yTsim(i,t) = yT 
y_total_sim(i,t) = r*asim(i,t) + ysim(i,t)
y_total_net_sim(i,t) = (1.0d0-tau_k)*r*asim(i,t) + yT - Tax_func(yT,zeta_1,zeta_2,dble(t)) + trans_sim(i,t)
elseif (model==1.0d0) then  
yT = ysim(i,t) - tau_ss_func(dble(t))*ysim(i,t)
rev_ss_sim(i,t) = tau_ss_func(dble(t))*ysim(i,t)
ltax(i,t) = Tax_func(yT,zeta_1,zeta_2,dble(t)) 
ltax1(i,t) = yT**(1.0d0-dble(alpha))
ltax2(i,t) = yT - zeta_2*((19.0d0+dble(t))/10.0d0)*(yT**(1.0d0-dble(alpha))) 
yTsim(i,t) = yT
y_total_sim(i,t) = r*asim(i,t) + ysim(i,t)
y_total_net_sim(i,t) = (1.0d0-tau_k)*r*asim(i,t) + yT - Tax_func(yT,zeta_1,zeta_2,dble(t)) + trans_sim(i,t)
endif  
if ((csim(i,t)>0.0d0).AND.(lsim(i,t)>=0.0d0).AND.(lsim(i,t)<1.0d0)) then
utility1_sim(i,t) = util(csim(i,t),lsim(i,t),dble(t),asim(i,t))
else
pause
endif
else
psim(i,t) = 0.0d0
Vsim(i,t) = V0
lsim(i,t) = 0.0d0
csim(i,t) = max(lininterp2(a,x,c_w_out(:,iu_sim(i,t),iz_sim(i,t),:,t),asim(i,t),xsim(i,t)),1d-10)
ysim(i,t) = y_func(lsim(i,t),u(iu_sim(i,t)),z(iz_sim(i,t)),t) 
res = (1.0d0+r)*asim(i,t) + ysim(i,t) + beq 
trans_sim(i,t) = trans(cmin,res)
if (model==0.0d0) then  
yT = ysim(i,t)-tau_ss*min(ysim(i,t),ymax)
rev_ss_sim(i,t) = tau_ss*min(ysim(i,t),ymax) 
ltax(i,t) = Tax_func(yT,zeta_1,zeta_2,dble(t))
ltax1(i,t) = yT**(1.0d0-dble(alpha))
ltax2(i,t) = yT - zeta_2*((19.0d0+dble(t))/10.0d0)*(yT**(1.0d0-dble(alpha))) 
yTsim(i,t) = yT 
y_total_sim(i,t) = r*asim(i,t) + ysim(i,t)
y_total_net_sim(i,t) = (1.0d0-tau_k)*r*asim(i,t) + yT - Tax_func(yT,zeta_1,zeta_2,dble(t)) + trans_sim(i,t)
elseif (model==1.0d0) then  
yT = ysim(i,t) - tau_ss_func(dble(t))*ysim(i,t)
rev_ss_sim(i,t) = tau_ss_func(dble(t))*ysim(i,t)
ltax(i,t) = Tax_func(yT,zeta_1,zeta_2,dble(t)) 
ltax1(i,t) = yT**(1.0d0-dble(alpha))
ltax2(i,t) = yT - zeta_2*((19.0d0+dble(t))/10.0d0)*(yT**(1.0d0-dble(alpha))) 
yTsim(i,t) = yT
y_total_sim(i,t) = r*asim(i,t) + ysim(i,t)
y_total_net_sim(i,t) = (1.0d0-tau_k)*r*asim(i,t) + yT - Tax_func(yT,zeta_1,zeta_2,dble(t)) + trans_sim(i,t)
endif  
if ((csim(i,t)>0.0d0).AND.(lsim(i,t)>=0.0d0).AND.(lsim(i,t)<1.0d0)) then
utility1_sim(i,t) = util_out(csim(i,t),lsim(i,t),dble(t),asim(i,t))
else
pause
endif
endif
enddo 
do i=1,nsim
do t=2,ret_age-1
call sim_w
enddo
t=ret_age
call sim_w_tr
do t=ret_age+1,ntime
call sim_ret
enddo
enddo 
mean_d_csim = sum(d_csim)/((dble(ret_age)-2.0d0)*dble(nsim))
mean_d_zsim = sum(d_zsim)/((dble(ret_age)-2.0d0)*dble(nsim))
mean_d_csim_low  = sum(d_csim_low)/((dble(ret_age)-2.0d0)*dble(nsim))
mean_d_zsim_low  = sum(d_zsim_low)/((dble(ret_age)-2.0d0)*dble(nsim))
mean_d_csim_high = sum(d_csim_high)/((dble(ret_age)-2.0d0)*dble(nsim))
mean_d_zsim_high = sum(d_zsim_high)/((dble(ret_age)-2.0d0)*dble(nsim))
mean_usim   = 0.0d0
mean_a1_age=0.0d0
mean_a2_age=0.0d0
mean_a3_age=0.0d0
mean_a4_age=0.0d0
mean_a5_age=0.0d0
mean_a6_age=0.0d0
mean_a7_age=0.0d0
mean_a8_age=0.0d0
mean_a9_age=0.0d0
aage = 0.0d0          
aage = 0.0d0          
xage = 0.0d0                    
lage = 0.0d0
page = 0.0d0
iage = 0.0d0                    
cage = 0.0d0
yage = 0.0d0
labor_age = 0.0d0
yage = 0.0d0
rev_ss_age = 0.0d0
tax_age = 0.0d0
tax_age1= 0.0d0
tax_age2= 0.0d0
t_age=0.0d0
trans_age=0.0d0
covar = 0.0d0
var = 0.0d0 
covar_u_a = 0.0d0
var_u = 0.0d0 
var_a = 0.0d0
covar_low  = 0.0d0
var_low = 0.0d0
covar_high = 0.0d0
var_high = 0.0d0
i2=0
i3=0
i15=0
do t=1,ntime
i1=0
i4=0
i5=0
i6=0
i7=0
i8=0
i9=0
i10=0
i11=0
i13=0
i14=0
do i=1,nsim  
i2=i2+1
a_all(i2) = asim(i,t)
y_all(i2) = y_total_sim(i,t)
y_all_net(i2) = y_total_net_sim(i,t)
pop(i2) = mu(t)/dble(nsim)
if (t<ret_age) then
i3=i3+1
tax_wage(i3)  = ltax(i,t)
wage(i3) = ysim(i,t)
endif
aage(t) = aage(t) + asim(i,t)/dble(nsim)
cage(t) = cage(t) + csim(i,t)/dble(nsim)
tax_age(t) = tax_age(t) + ltax(i,t)/dble(nsim)
tax_age1(t) = tax_age1(t) + ltax1(i,t)/dble(nsim)
tax_age2(t) = tax_age2(t) + ltax2(i,t)/dble(nsim)
trans_age(t) = trans_age(t) + trans_sim(i,t)/dble(nsim)
xage(t) = xage(t) + xsim(i,t)/dble(nsim)
if ( (t>1).and.(t<ret_age) ) then
covar = covar + ( d_csim(i,t) - mean_d_csim )*( d_zsim(i,t) - mean_d_zsim )
var = var   + ( d_zsim(i,t) - mean_d_zsim )**2.0d0
if (iu_sim(i,t)==1.0d0) then
covar_low  = covar_low  + ( d_csim(i,t) - mean_d_csim_low )*( d_zsim(i,t) - mean_d_zsim_low )
var_low = var_low + ( d_zsim(i,t) - mean_d_zsim_low )**2.0d0
elseif (iu_sim(i,t)==dble(ugrid)) then
covar_high = covar_high + ( d_csim(i,t) - mean_d_csim_high )*( d_zsim(i,t) - mean_d_zsim_high )
var_high = var_high + ( d_zsim(i,t) - mean_d_zsim_high )**2.0d0
endif
endif
if (t<ret_age) then
labor_age(t) = labor_age(t) + lsim(i,t)*dexp(u(iu_sim(i,t))+z(iz_sim(i,t)))*ef_temp(t) /dble(nsim)
rev_ss_age(t) = rev_ss_age(t) + rev_ss_sim(i,t)/dble(nsim)
if (psim(i,t)==1.0d0) then
i11 = i11 + 1
lage(t) = (lage(t)*(i11-1) + lsim(i,t))/dble(i11)
yage(t) = (yage(t)*(i11-1) + ysim(i,t))/dble(i11)
t_age(t) = (t_age(t)*(i11-1) + tsim(i,t))/dble(i11)
page(t) = page(t) + psim(i,t)/dble(nsim)
endif
else 
i15=i15+1    
y_all_ret(i15) = y_total_net_sim(i,t)
yage(t)        = yage(t)   + ysim(i,t)/dble(nsim)
if (iu_sim(i,t)==1.0d0) then
i4=i4+1
mean_a1_age(t) = (mean_a1_age(t)*(i4-1) + asim(i,t))/dble(i4)
elseif (iu_sim(i,t)==2.0d0) then
i5=i5+1
mean_a2_age(t) = (mean_a2_age(t)*(i5-1) + asim(i,t))/dble(i5)
elseif (iu_sim(i,t)==3.0d0) then
i6=i6+1
mean_a3_age(t) = (mean_a3_age(t)*(i6-1) + asim(i,t))/dble(i6)
elseif (iu_sim(i,t)==4.0d0) then
i7=i7+1
mean_a4_age(t) = (mean_a4_age(t)*(i7-1) + asim(i,t))/dble(i7)
elseif (iu_sim(i,t)==5.0d0) then
i8=i8+1
mean_a5_age(t) = (mean_a5_age(t)*(i8-1) + asim(i,t))/dble(i8)
elseif (iu_sim(i,t)==6.0d0) then
i9=i9+1
mean_a6_age(t) = (mean_a6_age(t)*(i9-1) + asim(i,t))/dble(i9)
elseif (iu_sim(i,t)==7.0d0) then
i10=i10+1
mean_a7_age(t) = (mean_a7_age(t)*(i10-1) + asim(i,t))/dble(i10)
elseif (iu_sim(i,t)==8.0d0) then
i13=i13+1
mean_a8_age(t) = (mean_a8_age(t)*(i13-1) + asim(i,t))/dble(i13)
elseif (iu_sim(i,t)==9.0d0) then
i14=i14+1
mean_a9_age(t) = (mean_a9_age(t)*(i14-1) + asim(i,t))/dble(i14)
endif
endif
enddo
enddo
var_a1_age=0.0d0
var_a2_age=0.0d0
var_a3_age=0.0d0
var_a4_age=0.0d0
var_a5_age=0.0d0
var_a6_age=0.0d0
var_a7_age=0.0d0
var_a8_age=0.0d0
var_a9_age=0.0d0
do t=ret_age,ntime
i1=0
i2=0
i3=0
i4=0
i5=0
i6=0
i7=0
i8=0
i9=0
do i=1,nsim  
if (iu_sim(i,t)==1.0d0) then
i1=i1+1
var_a1_age(t) = ( var_a1_age(t)*(i1-1) + ( ( asim(i,t) - mean_a1_age(t) )**2.0d0 ) )/dble(i1)
elseif (iu_sim(i,t)==2.0d0) then
i2=i2+1
var_a2_age(t) = ( var_a2_age(t)*(i2-1) + ( ( asim(i,t) - mean_a2_age(t) )**2.0d0 ) )/dble(i2)
elseif (iu_sim(i,t)==3.0d0) then
i3=i3+1
var_a3_age(t) = ( var_a3_age(t)*(i3-1) + ( ( asim(i,t) - mean_a3_age(t) )**2.0d0 ) )/dble(i3)
elseif (iu_sim(i,t)==4.0d0) then
i4=i4+1
var_a4_age(t) = ( var_a4_age(t)*(i4-1) + ( ( asim(i,t) - mean_a4_age(t) )**2.0d0 ) )/dble(i4)
elseif (iu_sim(i,t)==5.0d0) then
i5=i5+1
var_a5_age(t) = ( var_a5_age(t)*(i5-1) + ( ( asim(i,t) - mean_a5_age(t) )**2.0d0 ) )/dble(i5)
elseif (iu_sim(i,t)==6.0d0) then
i6=i6+1
var_a6_age(t) = ( var_a6_age(t)*(i6-1) + ( ( asim(i,t) - mean_a6_age(t) )**2.0d0 ) )/dble(i6)
elseif (iu_sim(i,t)==7.0d0) then
i7=i7+1
var_a7_age(t) = ( var_a7_age(t)*(i7-1) + ( ( asim(i,t) - mean_a7_age(t) )**2.0d0 ) )/dble(i7)
elseif (iu_sim(i,t)==8.0d0) then
i8=i8+1
var_a8_age(t) = ( var_a8_age(t)*(i8-1) + ( ( asim(i,t) - mean_a8_age(t) )**2.0d0 ) )/dble(i8)
elseif (iu_sim(i,t)==9.0d0) then
i9=i9+1
var_a9_age(t) = ( var_a9_age(t)*(i9-1) + ( ( asim(i,t) - mean_a9_age(t) )**2.0d0 ) )/dble(i9)
endif
enddo
enddo
am_t1 = mu(1)*sum(asim(:,1))/dble(nsim)
aage_l = 0.0d0                    
xage_l = 0.0d0                    
lage_l = 0.0d0
cage_l = 0.0d0
tage_l = 0.0d0
utility1_sim_low = 0.0d0
do t=1,ntime
i1=0
i2=0
do i=1,nsim  
if (iu_sim(i,t)==1.0d0) then
i1=i1+1
aage_l(t) = ((aage_l(t)*(i1-1) + asim(i,t))/dble(i1))
xage_l(t) = ((xage_l(t)*(i1-1) + xsim(i,t))/dble(i1))
cage_l(t) = ((cage_l(t)*(i1-1) + csim(i,t))/dble(i1))
utility1_sim_low(t) = utility1_sim_low(t) + utility1_sim(i,t)/dble(nsim_low)
if (psim(i,t)==1.0d0) then
i2=i2+1
lage_l(t) = ((lage_l(t)*(i2-1) + lsim(i,t))/dble(i2))
tage_l(t) = ((tage_l(t)*(i2-1) + tsim(i,t))/dble(i2))
endif
endif
enddo
enddo
aage_m = 0.0d0                    
xage_m = 0.0d0                    
lage_m = 0.0d0
cage_m = 0.0d0
tage_m = 0.0d0
do t=1,ntime
i1=0
i2=0
do i=1,nsim  
if (iu_sim(i,t)==5.0d0) then
i1=i1+1
aage_m(t) = ((aage_m(t)*(i1-1) + asim(i,t))/dble(i1))
xage_m(t) = ((xage_m(t)*(i1-1) + xsim(i,t))/dble(i1))
cage_m(t) = ((cage_m(t)*(i1-1) + csim(i,t))/dble(i1))
if (psim(i,t)==1.0d0) then
i2=i2+1
lage_m(t) = ((lage_m(t)*(i2-1) + lsim(i,t))/dble(i2))
tage_m(t) = ((tage_m(t)*(i2-1) + tsim(i,t))/dble(i2))
endif
endif
enddo
enddo
aage_h = 0.0d0                           
xage_h = 0.0d0                    
lage_h = 0.0d0
cage_h = 0.0d0
sage_h = 0.0d0
tage_h = 0.0d0
utility1_sim_high = 0.0d0
do t=1,ntime
i1=0
i2=0
do i=1,nsim  
if (iu_sim(i,t)==9.0d0) then
i1=i1+1
aage_h(t) = ((aage_h(t)*(i1-1) + asim(i,t))/dble(i1))
xage_h(t) = ((xage_h(t)*(i1-1) + xsim(i,t))/dble(i1))
cage_h(t) = ((cage_h(t)*(i1-1) + csim(i,t))/dble(i1))
utility1_sim_high(t) = utility1_sim_high(t) + utility1_sim(i,t)/dble(nsim_high)
if (psim(i,t)==1.0d0) then
i2=i2+1
lage_h(t) = ((lage_h(t)*(i2-1) + lsim(i,t))/dble(i2))
tage_h(t) = ((tage_h(t)*(i2-1) + tsim(i,t))/dble(i2))
endif
endif
enddo
enddo
y_age_m=0.0d0
do i=1,nsim  
t=1
if (psim(i,t)==1.0d0) then
y_age_m(i) = ysim(i,t)  
endif
do t=2,ret_age-1
if (psim(i,t)==1.0d0) then
y_age_m(i) = (y_age_m(i)*(t-1) + ysim(i,t))/dble(t)   
endif
enddo
enddo
!open(unit=981,file='profiles.txt',status='replace')
!do t = 1, ntime
!write(981,*) aage(t), lage(t), cage(t)
!enddo
!close(981)    
ltaxm = 0.0d0
ltaxm1 = 0.0d0
ltaxm2 = 0.0d0
am = 0.0d0
am_total = 0.0d0
lm = 0.0d0
labor = 0.0d0
inhe1 = 0.0d0
cm = 0.0d0
utility_m = 0.0d0
rev_w = 0.0d0
rev_ss = 0.0d0
xm = 0.0d0
savings_l = 0.0d0
savings_h = 0.0d0
total_savings_m = 0.0d0
savings_m = 0.0d0
bm = 0.0d0
tm = 0.0d0
trans_m = 0.0d0
beq = 0.0d0 
mean_a1 = 0.0d0
mean_a2 = 0.0d0
mean_a3 = 0.0d0
mean_a4 = 0.0d0
mean_a5 = 0.0d0
mean_a6 = 0.0d0
mean_a7 = 0.0d0
std_a1 = 0.0d0
std_a2 = 0.0d0
std_a3 = 0.0d0
std_a4 = 0.0d0
std_a5 = 0.0d0
std_a6 = 0.0d0
std_a7 = 0.0d0
std_a8 = 0.0d0
std_a9 = 0.0d0
pm = 0.0d0
do t = 1, ntime
am_total= am_total+ aage(t)*mu(t) 
xm = xm + xage(t)*mu(t)
lm = lm + lage(t)*(mu(t)/dble(sum(mu(1:ret_age-1))))
cm = cm + cage(t)*mu(t)    
trans_m = trans_m + trans_age(t)*mu(t)        
savings_m = savings_m + sav_age(t)*mu(t)
total_savings_m = total_savings_m + total_sav_age(t)*mu(t) 
savings_l = savings_l + savings_age_l(t)*mu(t) 
savings_h = savings_h + savings_age_h(t)*mu(t)    
if (t<ret_age) then
labor = labor + labor_age(t)*mu(t)   
rev_w = rev_w + yage(t)*mu(t)        
rev_ss = rev_ss + rev_ss_age(t)*mu(t)  
ltaxm = ltaxm + tax_age(t)*mu(t)     
ltaxm1 = ltaxm1 + tax_age1(t)*mu(t)    
ltaxm2 = ltaxm2 + tax_age2(t)*mu(t)    
tm = tm + t_age(t)*(mu(t)/dble(sum(mu(1:ret_age-1))))  
pm = pm + page(t)*(mu(t)/dble(sum(mu(1:ret_age-1))))
endif   
if (t>=ret_age) then
bm = bm + yage(t)*mu(t) 
mean_a1_new = mean_a1_new + mean_a1_age(t)*mu(t)
mean_a2_new = mean_a2_new + mean_a2_age(t)*mu(t)
mean_a3_new = mean_a3_new + mean_a3_age(t)*mu(t)
mean_a4_new = mean_a4_new + mean_a4_age(t)*mu(t)
mean_a5_new = mean_a5_new + mean_a5_age(t)*mu(t)
mean_a6_new = mean_a6_new + mean_a6_age(t)*mu(t)
mean_a7_new = mean_a7_new + mean_a7_age(t)*mu(t)
mean_a8_new = mean_a8_new + mean_a8_age(t)*mu(t)
mean_a9_new = mean_a9_new + mean_a9_age(t)*mu(t)
std_a1_new = std_a1_new + (var_a1_age(t)**0.5d0)*mu(t)    
std_a2_new = std_a2_new + (var_a2_age(t)**0.5d0)*mu(t)
std_a3_new = std_a3_new + (var_a3_age(t)**0.5d0)*mu(t)
std_a4_new = std_a4_new + (var_a4_age(t)**0.5d0)*mu(t)
std_a5_new = std_a5_new + (var_a5_age(t)**0.5d0)*mu(t)
std_a6_new = std_a6_new + (var_a6_age(t)**0.5d0)*mu(t)
std_a7_new = std_a7_new + (var_a7_age(t)**0.5d0)*mu(t)
std_a8_new = std_a8_new + (var_a8_age(t)**0.5d0)*mu(t)
std_a9_new = std_a9_new + (var_a9_age(t)**0.5d0)*mu(t)    
endif    
enddo
mean_a1 = 0.3d0*mean_a1_new + 0.70d0*mean_a1
mean_a2 = 0.3d0*mean_a2_new + 0.70d0*mean_a2
mean_a3 = 0.3d0*mean_a3_new + 0.70d0*mean_a3
mean_a4 = 0.3d0*mean_a4_new + 0.70d0*mean_a4
mean_a5 = 0.3d0*mean_a5_new + 0.70d0*mean_a5
mean_a6 = 0.3d0*mean_a6_new + 0.70d0*mean_a6
mean_a7 = 0.3d0*mean_a7_new + 0.70d0*mean_a7
mean_a8 = 0.3d0*mean_a8_new + 0.70d0*mean_a8
mean_a9 = 0.3d0*mean_a9_new + 0.70d0*mean_a9
std_a1 = 0.3d0*std_a1_new + 0.70d0*std_a1
std_a2 = 0.3d0*std_a2_new + 0.70d0*std_a2
std_a3 = 0.3d0*std_a3_new + 0.70d0*std_a3
std_a4 = 0.3d0*std_a4_new + 0.70d0*std_a4
std_a5 = 0.3d0*std_a5_new + 0.70d0*std_a5
std_a6 = 0.3d0*std_a6_new + 0.70d0*std_a6
std_a7 = 0.3d0*std_a7_new + 0.70d0*std_a7
std_a8 = 0.3d0*std_a8_new + 0.70d0*std_a8
std_a9 = 0.3d0*std_a9_new + 0.70d0*std_a9
EV1 = 0.0d0
EV1_ls = 0.0d0
EV1_hs = 0.0d0
i1=0
i2=0
do i = 1, nsim
EV1 = EV1 + Vsim(i,1)*(1.0d0/nsim)
if (iu_sim(i,1)==1.0d0) then    
i1=i1+1        
EV1_ls = (EV1_ls*(i1-1) + Vsim(i,1))/dble(i1)    
else if (iu_sim(i,1)==7.0d0) then  
i2=i2+1
EV1_hs = (EV1_hs*(i2-1) + Vsim(i,1))/dble(i2)    
end if             
enddo
debt = 0.0d0 		
am = am_total - debt
ym = grad*(w*labor) + (1.0d0-grad)*ym
Yf = tfp*(am**eta)*(labor**(1.0d0-eta))
kl1 = am/labor
errot = abs(kl1-kl)/kl
kl = grad*kl1 + (1.0d0-grad)*kl
ymax = 2.420d0*ym
r = eta*tfp*(kl**(eta-1.0d0)) - delta  
w = (1.0d0-eta)*tfp*(kl**eta)  			
GS = 0.07744d0    !0.16d0*Yf		
REV = rev_ss + ltaxm + tau_c*cm + tau_k*r*am_total  
!zeta_1 = zeta_1 + 1.0d0*( REV - GS - trans_m - bm - r*debt )
!tau_ss_0 = tau_ss_0 - 1.0d0*( REV - GS - trans_m - bm - r*debt )
!GS = REV - trans_m - bm - r*debt
cmin  = 0.10d0*ym
!r_ben = (1.0d0-tau_k)*r 
r_ben = r_ben + grad*(0.039851d0-bm/Yf)  !same size for the social security
!tau_ss_0 = tau_ss_0  + grad*(0.039851d0-bm/Yf)    !same size for the social security
write(*,*) 'same ss deficit'
tau_ss_0 = tau_ss_0 + (0.032269d0-rev_ss/Yf)
!b_min = p_min*ym
niter = niter + 1.0d0		                
if (model==0.0d0) then
xmin = 0.0001d0
xmax = ymax
x(1) = xmin
do i = 2,xgrid
x(i) = x(1) + (xmax/(dble(xgrid)**2.35d0))*(dble(i)**2.35d0)
enddo  
endif
cev=0.00d0
call fzero(cev,foc) 
cev_low=0.00d0
call fzero(cev_low,foc_low) 
cev_high=0.00d0
call fzero(cev_high,foc_high) 
cev_level=0.00d0
call fzero(cev_level,foc_level) 
write(*,*) 'iter =', niter        
write(*,*) 'erro =', errot
write(*,*) 'K/Y=', am/Yf
write(*,*) 'Y=', Yf, 'ym=', ym
write(*,*) 'capital=', am
write(*,*) 'labor=', labor
write(*,*) 'lm=', lm, 'pm=', pm
write(*,*) 'bm=', bm
write(*,*) 'rev_ss=', rev_ss
write(*,*) 'zeta_1 =', zeta_1
write(*,*) 'w =', w, 'r =', r
write(*,*) 'CEV ', CEV
write(*,*) 'CEV_low ', CEV_low, 'CEV_high ', CEV_high  
write(*,*) 'ins. coef', 1.0d0-covar/var
write(*,*) 'tau_ss_0', tau_ss_0, 'tau_ss_1', tau_ss_1
!OPEN(61, FILE="utility_bench.dat", FORM="unformatted")  
!DO t = 1, ntime  
!DO i = 1, nsim  
!utility_sim_bench(i,t) = utility1_sim(i,t)
!END DO
!END DO  
!WRITE(61) utility_sim_bench
!CLOSE(61) 
open(unit=848,file='income.txt',status='replace')
do i = 1, ntime*nsim
write(848,*) y_all(i), y_all_net(i), a_all(i), pop(i)
enddo
close(848)    
open(unit=850,file='wage.txt',status='replace')
do i = 1, (ret_age-1)*nsim
write(850,*) wage(i), tax_wage(i)
enddo
close(850)    
open(unit=854,file='income_ret.txt',status='replace')
do i = 1, nsim*(ntime-ret_age+1)
write(854,*) y_all_ret(i)
enddo
close(854)    
end subroutine simulation

end module mod_simulation


