module mod_solution
use mod_globvar
use mod_utilities
use CONJUGATE
use mod_bellman
use toolbox
implicit none
contains
subroutine solve_model
implicit none
real(8), parameter :: TOL  = 1.0d-6     
real(8), parameter :: EQL  = 1.0d-3     
real(8), parameter :: ftol = 0.0001d0     
real(8) :: fret
real(8) :: y_temp, pw_min(2), pw_max(2), xw_ndc(2,2), pw_ndc(2), pr(2), xw(2,2) , xr(2,2), cev, as, Vmax    
real(8) :: vp_c_l(nsim), vp_c_m(nsim), vp_c_h(nsim), pop_low, pop_med, pop_hig
real(8) :: vp_y_l(nsim), vp_y_m(nsim), vp_y_h(nsim), csim(nsim,ntime), ysim(nsim,ntime)      
integer :: iter, j 
if (model==0.0d0) then
tsol = ntime   
do ia = 1,agrid    
do ix = 1,xgrid  
xw = 0.0d0
xw(1,1) = 1.0d0
xw(2,2) = 1.0d0
pw = (/0.33d0,0.0d0/)		
call powell(2,pw,xw,ftol,iter,fret,bellman_ret_last_period)
a_ret(ia,ix,tsol) = pw(2) 
V_ret(ia,ix,tsol) = -fret
res = (1.0d0+r)*a(ia) + ben_func(x(ix)) + beq 
c_ret(ia,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + ben_func(x(ix)) + trans(cmin,res) + beq - pw(2) )/(1.0d0+tau_c),1d-10)
enddo
enddo
do tsol = ntime-1,ret_age,-1
do ia = 1,agrid    
do ix = 1,xgrid  
xw = 0.0d0
xw(1,1) = 1.0d0
xw(2,2) = 1.0d0
pw = (/0.33d0,0.0d0/)		
call powell(2,pw,xw,ftol,iter,fret,bellman_ret)
l_ret(ia,ix,tsol) = pw(1)
a_ret(ia,ix,tsol) = pw(2)
V_ret(ia,ix,tsol) = -fret	
res = (1.0d0+r)*a(ia) + ben_func(x(ix)) + beq 
c_ret(ia,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + ben_func(x(ix)) + trans(cmin,res) + beq - a_ret(ia,ix,tsol))/(1.0d0+tau_c),1d-10)
enddo
enddo
enddo
tsol = ret_age-1
do iu = 1,ugrid
do iz = 1,zgrid
do ia = 1,agrid
do ix = 1,xgrid
xw = 0.0d0
xw(1,1) = 1.0d0
xw(2,2) = 1.0d0
pw = (/0.33d0,0.0d0/)		
call powell(2,pw,xw,ftol,iter,fret,bellman_w_tr)
l_w(ia,iu,iz,ix,tsol) = pw(1)
a_w(ia,iu,iz,ix,tsol) = pw(2)                
V_w(ia,iu,iz,ix,tsol) = -fret
y_gross = y_func(pw(1),u(iu),z(iz),tsol) 
yT = y_gross - tau_ss*min(y_gross,ymax) 
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - pw(2))/(1.0d0+tau_c),1d-10)
as=amin
call fminsearch(as,Vmax,amin,amax,bellman_w_tr_out)
a_w_out(ia,iu,iz,ix,tsol) = as                
V_w_out(ia,iu,iz,ix,tsol) = -Vmax
y_gross = y_func(0.0d0,u(iu),z(iz),tsol) 
yT  = y_gross - tau_ss*min(y_gross,ymax)  
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w_out(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)
enddo
enddo
enddo
enddo
do tsol = ret_age-2,1,-1  
do iu = 1,ugrid
do iz = 1,zgrid
EV_w=0.0d0
do jz = 1,zgrid
EV_w(:,iu,iz,:) = EV_w(:,iu,iz,:) + Pr_z(iz,jz)*max(V_w(:,iu,jz,:,tsol+1),V_w_out(:,iu,jz,:,tsol+1))
enddo
do ia = 1,agrid
do ix = 1,xgrid
xw = 0.0d0
xw(1,1) = 1.0d0
xw(2,2) = 1.0d0
pw = (/0.33d0,0.0d0/)		
call powell(2,pw,xw,ftol,iter,fret,bellman_w)
l_w(ia,iu,iz,ix,tsol) = pw(1)
a_w(ia,iu,iz,ix,tsol) = pw(2)                
V_w(ia,iu,iz,ix,tsol) = -fret
y_gross = y_func(pw(1),u(iu),z(iz),tsol)
yT  = y_gross - tau_ss*min(y_gross,ymax)  
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - pw(2) )/(1.0d0+tau_c),1d-10)
as=amin
call fminsearch(as,Vmax,amin,amax,bellman_w_out)
a_w_out(ia,iu,iz,ix,tsol) = as                
V_w_out(ia,iu,iz,ix,tsol) = -Vmax
y_gross = y_func(0.0d0,u(iu),z(iz),tsol) 
yT= y_gross - tau_ss*min(y_gross,ymax) 
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w_out(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)
enddo
enddo
enddo
enddo
enddo                                                                    
elseif (model==1.0d0) then  
tsol = ntime   
do ia = 1,agrid    
do ix = 1,xgrid  
xw = 0.0d0
xw(1,1) = 1.0d0
xw(2,2) = 1.0d0
pw = (/0.33d0,0.0d0/)		
call powell(2,pw,xw,ftol,iter,fret,bellman_ret_last_period)
a_ret(ia,ix,tsol) = pw(2)
V_ret(ia,ix,tsol) = -fret               
res = (1.0d0+r)*a(ia) + ben_func(x(ix)) + beq 
c_ret(ia,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + ben_func(x(ix)) + trans(cmin,res) + beq - pw(2) )/(1.0d0+tau_c),1d-10)
enddo
enddo
do tsol = ntime-1,ret_age,-1
do ia = 1,agrid    
do ix = 1,xgrid  
xr = 0.0d0
xr(1,1) = 1.0d0
xr(2,2) = 1.0d0
pr = (/0.33d0,0.0d0/)		
call powell(2,pr,xr,ftol,iter,fret,bellman_ret)
l_ret(ia,ix,tsol) = pr(1)
a_ret(ia,ix,tsol) = pr(2)
V_ret(ia,ix,tsol) = -fret	
res = (1.0d0+r)*a(ia) + ben_func(x(ix)) + beq 
c_ret(ia,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + ben_func(x(ix)) + trans(cmin,res) + beq - a_ret(ia,ix,tsol))/(1.0d0+tau_c),1d-10)
enddo
enddo
enddo
tsol = ret_age-1
do ia = 1,agrid   
do iu = 1,ugrid
do iz = 1,zgrid
do ix = 1,xgrid
xw_ndc = 0.0d0
xw_ndc(1,1) = 1.0d0
xw_ndc(2,2) = 1.0d0
pw_ndc = (/0.33d0,0.0d0/)		
call powell(2,pw_ndc,xw_ndc,ftol,iter,fret,bellman_w_tr_ndc)
l_w(ia,iu,iz,ix,tsol) = pw_ndc(1)
a_w(ia,iu,iz,ix,tsol) = pw_ndc(2)                
V_w(ia,iu,iz,ix,tsol) = -fret
y_gross = y_func(pw_ndc(1),u(iu),z(iz),tsol)
yT = y_gross - tau_ss_func(dble(tsol))*y_gross
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - pw_ndc(2))/(1.0d0+tau_c),1d-10)
as=amin
call fminsearch(as,Vmax,amin,amax,bellman_w_tr_ndc_out)
a_w_out(ia,iu,iz,ix,tsol) = as
V_w_out(ia,iu,iz,ix,tsol) = -Vmax
y_gross  = y_func(0.0d0,u(iu),z(iz),tsol)
yT = y_gross - tau_ss_func(dble(tsol))*y_gross
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w_out(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as)/(1.0d0+tau_c),1d-10)
enddo
enddo
enddo
enddo
do tsol = ret_age-2,1,-1
do iu = 1,ugrid
do iz = 1,zgrid
EV_w=0.0d0
do jz = 1,zgrid
EV_w(:,iu,iz,:) = EV_w(:,iu,iz,:) + Pr_z(iz,jz)*max(V_w(:,iu,jz,:,tsol+1),V_w_out(:,iu,jz,:,tsol+1))
enddo
do ia = 1,agrid
do ix = 1,xgrid
xw_ndc = 0.0d0
xw_ndc(1,1) = 1.0d0
xw_ndc(2,2) = 1.0d0
pw_ndc = (/0.33d0,0.0d0/)		
call powell(2,pw_ndc,xw_ndc,ftol,iter,fret,bellman_w_ndc)
l_w(ia,iu,iz,ix,tsol) = pw_ndc(1)
a_w(ia,iu,iz,ix,tsol) = pw_ndc(2)                
V_w(ia,iu,iz,ix,tsol) = -fret
y_gross = y_func(pw_ndc(1),u(iu),z(iz),tsol)
yT = y_gross - tau_ss_func(dble(tsol))*y_gross  
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - pw_ndc(2) )/(1.0d0+tau_c),1d-10)
as=amin
call fminsearch(as,Vmax,amin,amax,bellman_w_ndc_out)
a_w_out(ia,iu,iz,ix,tsol) = as
V_w_out(ia,iu,iz,ix,tsol) = -Vmax
y_gross = y_func(0.0d0,u(iu),z(iz),tsol)
yT = y_gross - tau_ss_func(dble(tsol))*y_gross
res = (1.0d0+r)*a(ia) + y_gross + beq 
c_w_out(ia,iu,iz,ix,tsol) = max(((1.0d0+(1.0d0-tau_k)*r)*a(ia) + yT - Tax_func(yT,zeta_1,zeta_2,dble(tsol)) + trans(cmin,res) + beq - as )/(1.0d0+tau_c),1d-10)
enddo
enddo
enddo
enddo
enddo                                                                    
endif
end subroutine solve_model
end module mod_solution